﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace howto_buttons_over_picture2
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            Button[] buttons = { button1, button2,
                button3, button4, button5, button6 };
            foreach (Button btn in buttons)
                SetButtonBackground(pictureBox1, btn, 128);
        }

        // Make the Button display the part of the
        // PictureBox's picture that is under it.
        private void SetButtonBackground(PictureBox pic, Button btn, byte alpha)
        {
            // Get the offset between the PictureBox's
            // and button's upper left corners.
            Point pic_pt = new Point(0, 0);
            pic_pt = pic.PointToScreen(pic_pt);
            Point btn_pt = new Point(0, 0);
            btn_pt = btn.PointToScreen(btn_pt);
            int x_offset = btn_pt.X - pic_pt.X;
            int y_offset = btn_pt.Y - pic_pt.Y;

            // Get the button's size.
            int wid = btn.ClientSize.Width;
            int hgt = btn.ClientSize.Height;

            // Make a bitmap to hold the button image.
            Bitmap bm = new Bitmap(wid, hgt);
            using (Graphics gr = Graphics.FromImage(bm))
            {
                // Destination rectangle.
                Rectangle dest_rect = new Rectangle(0, 0, wid, hgt);

                // Source rectangle.
                Rectangle src_rect = new Rectangle(x_offset, y_offset, wid, hgt);

                // Copy the image under the button into the bitmap.
                gr.DrawImage(pic.Image, dest_rect, src_rect, GraphicsUnit.Pixel);

                // Draw some gray over the image.
                Color color = Color.FromArgb(alpha, Color.White);
                using (Brush brush = new SolidBrush(color))
                {
                    gr.FillRectangle(brush, dest_rect);
                }
            }

            // Make the button display the image.
            btn.Image = bm;
        }
    }
}
